"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.command = void 0;
const constants_1 = require("../constants");
const revision_1 = require("../revision");
const print_1 = require("../print");
const command = (config, ...args) => __awaiter(void 0, void 0, void 0, function* () {
    var _a;
    console.log('New revision...');
    (0, print_1.printConfig)(config);
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    const [_commandName, description] = args;
    if (description === undefined) {
        throw new Error('missing description');
    }
    const revisionFile = yield (0, revision_1.newRevision)({
        directory: (_a = config === null || config === void 0 ? void 0 : config.revisionsDirectory) !== null && _a !== void 0 ? _a : constants_1.DEFAULT_REVISIONS_DIRECTORY,
        description
    });
    console.log(`file: ${revisionFile}`);
});
exports.command = command;
