"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.command = void 0;
const path_1 = require("path");
const print_1 = require("../print");
const command = (config, db, state, service, ...args) => __awaiter(void 0, void 0, void 0, function* () {
    var _a;
    console.log('Fetching current revision...');
    (0, print_1.printConfig)(config);
    console.log('---');
    let currentRevision;
    yield db.transaction((client) => __awaiter(void 0, void 0, void 0, function* () {
        yield state.initialize(client);
        currentRevision = yield service.fetchCurrentRevision(client, {
            namespace: config.revisionsNamespace
        });
    }));
    if (currentRevision === undefined) {
        console.log('version: (base)');
    }
    else {
        const displayPreviousVersion = (_a = currentRevision.previousVersion) !== null && _a !== void 0 ? _a : '(base)';
        const displayVersion = currentRevision.version;
        const displayFile = (0, path_1.basename)(currentRevision.file);
        console.log(`previous:   ${displayPreviousVersion}`);
        console.log(`version:    ${displayVersion}`);
        console.log(`file:       ${displayFile}`);
        if (currentRevision.createdAt !== undefined) {
            console.log(`created at: ${currentRevision.createdAt.toISOString()}`);
        }
        if (currentRevision.updatedAt !== undefined) {
            console.log(`updated at: ${currentRevision.updatedAt.toISOString()}`);
        }
    }
});
exports.command = command;
