"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.saveConfig = exports.loadConfig = exports.getConfigPath = void 0;
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const constants_1 = require("./constants");
const getConfigPath = () => {
    var _a;
    return (_a = process.env.REVISIONS_CONFIG) !== null && _a !== void 0 ? _a : path_1.default.resolve(process.cwd(), constants_1.DEFAULT_REVISIONS_CONFIG);
};
exports.getConfigPath = getConfigPath;
const loadConfig = () => __awaiter(void 0, void 0, void 0, function* () {
    var _a;
    const configPath = (0, exports.getConfigPath)();
    if (fs_1.default.existsSync(configPath)) {
        return yield (_a = configPath, Promise.resolve().then(() => __importStar(require(_a))));
    }
});
exports.loadConfig = loadConfig;
const saveConfig = (args) => __awaiter(void 0, void 0, void 0, function* () {
    const configLines = [];
    configLines.push('const path = require(\'path\');');
    configLines.push('');
    configLines.push('module.exports = {');
    configLines.push(
    // eslint-disable-next-line @typescript-eslint/restrict-template-expressions
    `  revisionsNamespace: '${args.namespace}',`);
    configLines.push(
    // eslint-disable-next-line @typescript-eslint/restrict-template-expressions
    `  revisionsDirectory: path.resolve(__dirname, '${args.directory}'),`);
    if (args.connectionManagerModuleName === undefined) {
        configLines.push('  connectionManagerModule: {');
        configLines.push('    getConnectionManager: () => {');
        configLines.push('      throw new Error(\'not implemented\');');
        configLines.push('    },');
        configLines.push('  },');
    }
    else {
        configLines.push(
        // eslint-disable-next-line @typescript-eslint/restrict-template-expressions
        `  connectionManagerModule: require('${args.connectionManagerModuleName}'),`);
    }
    if (args.stateManagerModuleName === undefined) {
        configLines.push('  stateManagerModule: {');
        configLines.push('    getStateManager: () => {');
        configLines.push('      throw new Error(\'not implemented\');');
        configLines.push('    },');
        configLines.push('  },');
    }
    else {
        configLines.push(
        // eslint-disable-next-line @typescript-eslint/restrict-template-expressions
        `  stateManagerModule: require('${args.stateManagerModuleName}'),`);
    }
    configLines.push('};');
    configLines.push('');
    const configContent = configLines.join('\n');
    const configPath = (0, exports.getConfigPath)();
    fs_1.default.writeFileSync(configPath, configContent);
    console.log(`config file: ${configPath}`);
});
exports.saveConfig = saveConfig;
